package com.okseby.win;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.UIManager;
import javax.swing.border.EtchedBorder;

public class Window implements Runnable {
	JFrame window;
	JMenuBar menuBar;
	JMenu fileMenu;
	JMenu editMenu;
	JButton quitButton;
	JMenuItem fileMenuItem1, fileMenuItem2, fileMenuItem3;
	JPanel fileExplorer;
	JPanel mainPanel;
	JTextArea textArea;
	
	String title;
	double version;
	Dimension winSize;
	
	public void setup() {
		menuBar.add(fileMenu);
		menuBar.add(editMenu);
		menuBar.add(Box.createHorizontalGlue());
		menuBar.add(quitButton);
		
		fileMenu.add(fileMenuItem1);
		fileMenu.add(fileMenuItem2);
		fileMenu.add(fileMenuItem3);
		
		quitButton.setContentAreaFilled(false);
		quitButton.setBorderPainted(false);
		quitButton.setFocusable(false);
		
		quitButton.addMouseListener(new java.awt.event.MouseAdapter() {
		    public void mouseEntered(java.awt.event.MouseEvent evt) {
		    	quitButton.setContentAreaFilled(true);
		    	quitButton.setBackground(Color.RED);
		    }

		    public void mouseExited(java.awt.event.MouseEvent evt) {
		    	quitButton.setContentAreaFilled(false);
		    	quitButton.setBackground(UIManager.getColor("control"));
		    }
		});
		
		quitButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});
		
		fileExplorer.setBorder(new EtchedBorder());
		fileExplorer.setBackground(new Color(0, 0, 0));
		fileExplorer.setPreferredSize(new Dimension(200, 200));
		
		mainPanel.setLayout(new BorderLayout());
		mainPanel.setBorder(new EtchedBorder());
		mainPanel.add(textArea);
		
		window.add(fileExplorer, BorderLayout.WEST);
		window.add(mainPanel);
		
		window.setTitle(title);
		window.setSize(winSize);
		window.setJMenuBar(menuBar);
		window.setLocationRelativeTo(null);
		window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		window.setVisible(true);
	}
	
	public void build() {
		window = new JFrame();
		menuBar = new JMenuBar();
		fileMenu = new JMenu("File");
		editMenu = new JMenu("Edit");
		quitButton = new JButton("Quit");
		fileMenuItem1 = new JMenuItem("Open");
		fileMenuItem2 = new JMenuItem("Save");
		fileMenuItem3 = new JMenuItem("Close File");
		fileExplorer = new JPanel();
		mainPanel = new JPanel();
		textArea = new JTextArea();
	}

	@Override
	public void run() {
		build();
		setup();
	}
	
	public Window(String title, double version, Dimension winSize) {
		this.title = title + version;
		this.winSize = winSize;
	}
}
